/*
 * tBbg̃Xg߂̃NX
 *
 * Copyright 2000 by Information-technology Promotion Agency, Japan
 * Copyright 2000 by Precision Modeling Laboratory, Inc., Tokyo, Japan
 * Copyright 2000 by Software Research Associates, Inc., Tokyo, Japan
 *
 * $Id: JgclFilletObjectList.java,v 1.5 2000/04/26 09:38:55 hideit Exp $
 */

package jp.go.ipa.jgcl;
import java.util.*;

/**
 * tBbg̃Xg߂̃NX
 *
 * @version $Revision: 1.5 $, $Date: 2000/04/26 09:38:55 $
 * @author Information-technology Promotion Agency, Japan
 */

class JgclFilletObjectList {
    /**
     * tBbg̃Xg
     * @see Vector
     */
    Vector list;

    /*
     * RXgN^
     */
    JgclFilletObjectList() {
	super();
	list = new Vector();
    }

    /*
     * tBbgȐǉB
     * ɓ݂Ƃ͒ǉȂB
     * @param theFilletObject	ǉtBbgȐ
     * @see	JgclFilletObject2D
     */
    void addFillet(JgclFilletObject2D theFilletObject) {
	JgclFilletObject2D mate;

	for (Enumeration en = list.elements(); en.hasMoreElements();) {
	    if (theFilletObject.parametricallyIdentical((JgclFilletObject2D)en.nextElement()))
		return;
	}
	list.addElement(theFilletObject);
    }

    /**
     * tBbgȐzƂĎoB
     * @return	tBbgȐ̔z
     * @see	JgclFilletObject2D
     */
    JgclFilletObject2D[] toJgclFilletObject2DArray(boolean doExchange) {
	JgclFilletObject2D[] flts = new JgclFilletObject2D[list.size()];
	list.copyInto(flts);
	if (doExchange)
	    for (int i = 0; i < flts.length; i++)
		flts[i] = flts[i].exchange();
	return flts;
    }

    /*
     * tBbgfʏǉB
     * ŌɒǉꂽfʂƓ̏ꍇ͒ǉȂB
     * @param theFilletObject	ǉtBbgfʏ
     * @see	JgclFilletSection3D
     */
    void addSection(JgclFilletSection3D theFilletSection) {
	if (list.size() > 0) {
	    if (theFilletSection.parametricallyIdentical((JgclFilletSection3D)list.lastElement()))
		return;
	}
	list.addElement(theFilletSection);
    }

    /**
     * tBbgfʏtBbgȖʏ񂵂ĎoB
     * @return	tBbgȖʏ(fʂ̐2ɖȂꍇnullԂ)
     * @see	JgclFilletObject3D
     */
    JgclFilletObject3D toJgclFilletObject3D(boolean doExchange) {
	int nSecs;
	if ((nSecs = list.size()) < 2)
	    return null;

	JgclFilletSection3D[] secs = new JgclFilletSection3D[nSecs];
	list.copyInto(secs);
	if (doExchange)
	    for (int i = 0; i < secs.length; i++)
		secs[i] = secs[i].exchange();
	return new JgclFilletObject3D(secs);
    }

    /*
     * tBbgȖʏǉB
     * ł͒Pɒǉ̂݁B
     * @param theFilletObject	ǉtBbgȖʏ
     * @see	JgclFilletObject3D
     */
    void addFillet(JgclFilletObject3D theFilletObject) {
	list.addElement(theFilletObject);
    }

    /**
     * tBbgȖʏzƂĎoB
     * @return	tBbgȐ̔z
     * @see	JgclFilletObject3D
     */
    JgclFilletObject3D[] toJgclFilletObject3DArray(boolean doExchange) {
	JgclFilletObject3D[] flts = new JgclFilletObject3D[list.size()];
	list.copyInto(flts);
	if (doExchange)
	    for (int i = 0; i < flts.length; i++)
		flts[i] = flts[i].exchange();
	return flts;
    }
}

// end of file
