/*
 * R : _̏ɂ_\NX
 *
 * Copyright 2000 by Information-technology Promotion Agency, Japan
 * Copyright 2000 by Precision Modeling Laboratory, Inc., Tokyo, Japan
 * Copyright 2000 by Software Research Associates, Inc., Tokyo, Japan
 *
 * $Id: JgclPointOnPoint3D.java,v 1.25 2000/08/11 06:18:57 shikano Exp $
 *
 */

package jp.go.ipa.jgcl;

import java.io.OutputStream;
import java.io.PrintWriter;

/**
 * R : _̏ɂ_\NXB
 * <p>
 * ̃NX̃CX^X́A
 * _̏Ă_ ({@link JgclPoint3D JgclPoint3D})
 * basisPoint ێB
 * </p>
 *
 * @version $Revision: 1.25 $, $Date: 2000/08/11 06:18:57 $
 * @author Information-technology Promotion Agency, Japan
 * @see	JgclPointOnCurve3D
 */

public class JgclPointOnPoint3D extends JgclPointOnGeometry3D {
    /**
     * _̏Ă_B
     * @serial
     */
    private JgclPoint3D basisPoint;

    /**
     * _̏Ă_^ăIuWFNg\zB
     * <p>
     * JgclPointOnGeometry3D ɂ point  null ɐݒ肳B
     * </p>
     * <p>
     * doCheck  true ̏ꍇɂ́A̒lɑ΂Ĉȉ̌sȂB
     * <ul>
     * <li>	basisPoint  null ̏ꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * <li>	point  null łȂA
     *		point  basisPoint vȂꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * </ul>
     * </p>
     *
     * @param basisPoint _̏Ă_
     * @param doCheck	̒l̑Ó`FbN邩ǂ̃tO
     * @see	JgclInvalidArgumentValue
     * @see	JgclPoint3D#identical(JgclPoint3D)
     */
    JgclPointOnPoint3D(JgclPoint3D basisPoint, boolean doCheck)
    {
        this(null, basisPoint, doCheck);
    }

    /**
     * _̍Wl
     * _̏Ă_^ăIuWFNg\zB
     * <p>
     * point  null ł\ȂB
     * </p>
     * <p>
     * doCheck  true ̏ꍇɂ́A̒lɑ΂Ĉȉ̌sȂB
     * <ul>
     * <li>	basisPoint  null ̏ꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * <li>	point  null łȂA
     *		point  basisPoint vȂꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * </ul>
     * </p>
     *
     * @param point	__̍Wl
     * @param basisPoint _̏Ă_
     * @param doCheck	̒l̑Ó`FbN邩ǂ̃tO
     * @see	JgclInvalidArgumentValue
     * @see	JgclPoint3D#identical(JgclPoint3D)
     */
    JgclPointOnPoint3D(JgclPoint3D point,
                       JgclPoint3D basisPoint,
                       boolean doCheck)
    {
        super(point);
        if (doCheck == true) {
            if (basisPoint == null) {
                throw new JgclInvalidArgumentValue();
            }
            if (point != null) {
                if (!point.identical(basisPoint)) {
                    throw new JgclInvalidArgumentValue();
                }
            }
        }
        this.basisPoint = basisPoint;
    }

    /**
     * _̏Ă_^ăIuWFNg\zB
     * <p>
     * JgclPointOnGeometry3D ɂ point  null ɐݒ肳B
     * </p>
     * <p>
     * ̒lɑ΂Ĉȉ̌sȂB
     * <ul>
     * <li>	basisPoint  null ̏ꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * <li>	point  null łȂA
     *		point  basisPoint vȂꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * </ul>
     * </p>
     *
     * @param basisPoint _̏Ă_
     * @see	JgclInvalidArgumentValue
     * @see	JgclPoint3D#identical(JgclPoint3D)
     */
    public JgclPointOnPoint3D(JgclPoint3D basisPoint)
    {
        this(null, basisPoint);
    }

    /**
     * _̍Wl
     * _̏Ă_^ăIuWFNg\zB
     * <p>
     * point  null ł\ȂB
     * </p>
     * <p>
     * ̒lɑ΂Ĉȉ̌sȂB
     * <ul>
     * <li>	basisPoint  null ̏ꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * <li>	point  null łȂA
     *		point  basisPoint vȂꍇɂ́A
     *		JgclInvalidArgumentValue ̗O𔭐B
     * </ul>
     * </p>
     *
     * @param point	__̍Wl
     * @param basisPoint _̏Ă_
     * @see	JgclInvalidArgumentValue
     * @see	JgclPoint3D#identical(JgclPoint3D)
     */
    public JgclPointOnPoint3D(JgclPoint3D point, JgclPoint3D basisPoint)
    {
        this(point, basisPoint, true);
    }

    /**
     * x[XƂȂ`vfԂB
     * <p>
     * ʂƂĕԂ`vf
     * JgclPoint3D ̃CX^XłB
     * </p>
     *
     * @return	x[XƂȂ`vf
     * @see	#basisPoint()
     */
    public JgclGeometry geometry() {
    	return basisPoint();
    }

    /**
     * x[XƂȂ_ԂB
     *
     * @return x[XƂȂ_
     * @see	#geometry()
     */
    public JgclPoint3D basisPoint() {
        return basisPoint;
    }

    /**
     * x[XƂȂ`vfɑ΂񂩂_̍Wl߂B
     *
     * @return	x[XƂȂ`vfɑ΂񂩂狁߂_̍Wl
     * @see	#basisPoint()
     */
    JgclPoint3D coordinates() {
        return basisPoint();
    }

    /**
     * ̓_A^ꂽ􉽓IϊZqŕϊB
     * <p>
     * transformedGeometries ́A
     * ϊO̊􉽗vfL[ƂA
     * ϊ̊􉽗vflƂnbVe[ułB
     * </p>
     * <p>
     * this  transformedGeometries ɃL[Ƃđ݂Ȃꍇɂ́A
     * this  transformationOperator ŕϊ̂ԂB
     * ̍ۂɃ\bhł this L[A
     * ϊʂlƂ transformedGeometries ɒǉB
     * </p>
     * <p>
     * this  transformedGeometries ɊɃL[Ƃđ݂ꍇɂ́A
     * ۂ̕ϊ͍sȂ킸ÃL[ɑΉlԂB
     * ͍̏ċAIɍsȂB
     * </p>
     * <p>
     * transformedGeometries  null ł\ȂB
     * transformedGeometries  null ̏ꍇɂ́A
     *  this  transformationOperator ŕϊ̂ԂB
     * </p>
     *
     * @param reverseTransform		tϊ̂ł trueAłȂ false
     * @param transformationOperator	􉽓IϊZq
     * @param transformedGeometries	ɓl̕ϊ{􉽗vf܂ރnbVe[u
     * @return	ϊ̊􉽗vf
     */
    protected synchronized JgclPoint3D
    doTransformBy(boolean reverseTransform,
		  JgclCartesianTransformationOperator3D transformationOperator,
		  java.util.Hashtable transformedGeometries)
    {
	JgclPoint3D tPoint = this.point();
	if (tPoint != null)
	    tPoint = tPoint.transformBy(reverseTransform,
					transformationOperator, transformedGeometries);
	JgclPoint3D tBasisPoint =
	    this.basisPoint.transformBy(reverseTransform,
					transformationOperator, transformedGeometries);

	return new JgclPointOnPoint3D(tPoint, tBasisPoint, doCheckDebug);
    }

    /**
     * o̓Xg[Ɍ`o͂B
     *
     * @param writer    PrintWriter
     * @param indent	Cfg̐[
     * @see		JgclGeometry
     */
    protected void output(PrintWriter writer, int indent) {
        String indent_tab = makeIndent(indent);

        writer.println(indent_tab + getClassName());
        basisPoint.output(writer, indent + 2);
        writer.println("End");
    }
}
